#!/usr/bin/env python
# -*- coding: UTF-8 -*-


# Always prefer setuptools over distutils
from setuptools import setup, find_packages
# To use a consistent encoding
from codecs import open
from os import path

here = path.abspath(path.dirname(__file__))

# Get the long description from the README file
with open(path.join(here, 'README.rst'), encoding='utf-8') as f:
        long_description = f.read()

setup(
      name='np-simulator',
      packages=['np-simulator'],
      version='0.9.0',
      description='TCP packet simulation program',
      long_description=long_description,

      url='http://www.penatasecurity.com',
      author='morenice',
      author_email='hyounggu_lee@pentasecurity.com',
      license='MIT',

      classifiers=[
          # How mature is this project? Common values are
          #   3 - Alpha
          #   4 - Beta
          #   5 - Production/Stable
          'Development Status :: 3 - Alpha',
          'License :: OSI Approved :: MIT License',
          'Topic :: Software Development',
          'Topic :: System :: Networking',
          'Programming Language :: Python :: 2',
          'Programming Language :: Python :: 2.6',
          'Programming Language :: Python :: 2.7',
          ],

      install_requires=['scapy>=2.1.0'],
    )

